#include <stdio.h>
#include <unistd.h>
#include "daware.h"

#define DATA_FILE "/tmp/daware-termination.dat"

int termination_flag = 0;

int
termination_callback (int signo, void *arg)
{
  termination_flag = 1;
  return 0;
}

int
main (int argc, char *argv[])
{
  printf("PID: %d\n", getpid());

  DTermination *dterm = daware_termination_register_callback
    (SIGTERM, termination_callback, NULL);

  int val = 0;

  FILE *fp = fopen(DATA_FILE, "rb");
  if (fp) {
    if (fread(&val, sizeof(val), 1, fp) != 1) val = 0;
    fclose(fp);
    printf("load: %d < %s\n", val, DATA_FILE);
  }

  while (1) {
    printf("%d\n", val);
    if (termination_flag) break;
    val++;
    sleep(1);
  }

  fp = fopen(DATA_FILE, "wb");
  if (fp) {
    printf("save: %d > %s\n", val, DATA_FILE);
    fwrite(&val, sizeof(val), 1, fp);
    fclose(fp);
  }

  daware_termination_unregister_callback(dterm);

  return 0;
}

